<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@page import="org.wso2.carbon.identity.provider.ui.client.IdentityProviderClient"%>
<jsp:include page="../dialog/display_messages.jsp"/>

<%@page import="org.wso2.carbon.identity.provider.ui.client.RelyingPartyClient"%>
<%@page import="org.wso2.carbon.identity.provider.ui.rp.dto.UserTrustedRPDTO"%>
<script type="text/javascript" src="global-params.js"></script>

<%
String backendServerURL;
ConfigurationContext configContext;
String cookie;
RelyingPartyClient client = null;
UserTrustedRPDTO[] userTrustedRPs = null;
String user = null;

backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
configContext = (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
client = new RelyingPartyClient(cookie, backendServerURL,configContext);

try {
	user = (String) session.getAttribute("logged-user");
	userTrustedRPs = client.getAllUserTrustedRelyingParties(user);
} catch (Exception e) {
    CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
	<script type="text/javascript">
		    location.href = "../admin/error.jsp";
	</script>
<%
	return;
}
%>

<fmt:bundle basename="org.wso2.carbon.identity.provider.ui.i18n.Resources">
<carbon:breadcrumb 
		label="trusted.rps"
		resourceBundle="org.wso2.carbon.identity.provider.ui.i18n.Resources"
		topPage="true" 
		request="<%=request%>" />
		
<script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
<script type="text/javascript" src="../carbon/admin/js/main.js"></script>

<div id="middle">
    <h2 id="identity"><fmt:message key="trusted.rp.header"/></h2>
    <script type="text/javascript">
        function validate() {
            var cert = document.rpcertUpload.rpcert.value;
            if (cert == '') {
                CARBON.showWarningDialog('<fmt:message key="please.select.a.certificate.to.upload"/>');
            } else if (cert.lastIndexOf(".cer") == -1) {
                CARBON.showWarningDialog('<fmt:message key="please.select.der.encoded"/>');
            } else {
                document.rpcertUpload.submit();
            }
        }
        function remove(hostName) {
        	CARBON.showConfirmationDialog('<fmt:message key="remove.message1"/>'+ hostName +'<fmt:message key="remove.message2"/>',
                    function() {
              	       location.href = "remove-trusted-rp.jsp?hostName="+hostName;
                     }, null);
        }
    </script>
    <div id="workArea">
       	<table cellspacing="0" class="normal">
      			<tr height="6"><td colspan="2"></td></tr>
		     	<tr>		     	   
			    				    	
			    	<td align="left"><img src="images/rp-trust.jpg" align="top">
			    	    <fmt:message key="managed.infocard.message"/>
			    	</td>
				</tr>
		</table>
    	<form method="post" name="rpcertUpload" action="import-cert-finish.jsp"
                  enctype="multipart/form-data" target="_self">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="upload.new.rp.cert"/></th>
                    </tr>
                    </thead>
                    <tr>
                        <td class="formRow">
                            <table class="normal">
                                <tr>
                                    <td>
                                        <label><fmt:message key="rp.cert"/></label>
                                    </td>
                                    <td>
                                        <input type="file" id="rpcert" name="rpcert" size="50"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <input name="upload" type="button" class="button"
                                   value="<fmt:message key='upload'/>"
                                   onclick="validate();"/>
                        </td>
                    </tr>
                </table>
            </form>    
            <br/><br/>
            <form method="post" name="certList" action="remove-trusted-rp.jsp" target="_self">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th colspan="2"><fmt:message key="personal.trusted.rps"/></th>
                    </tr>
                    </thead>
                    	<%
                    	if (userTrustedRPs != null && userTrustedRPs.length>0) {
                        for (UserTrustedRPDTO rp : userTrustedRPs) {
                        if(rp!= null) {
                        %>							
							<tr>
							   <td width="50%"><%=rp.getCertificateAlias()%></td>
							   <td width="45%">
							   <a title="<fmt:message key='remove.trusted.rps'/>"
                                   onclick="remove('<%=rp.getHostName()%>');return false;"
                                   href="#">
                                    <img src="images/delete.gif" alt="<fmt:message key='remove.trusted.rps'/>"/>
                                </a>&nbsp;</td>
                            </tr>							
						<%
						 } }
                    	}else {                    	
						%>
						<tr><td colspan="2"><fmt:message key="no.trusted.rps"/></td></tr>
						<%}%>
                    <tr>
                    </tr>               
                </table>
            </form> 
    </div>
</div>
</fmt:bundle>